#ifndef MIN_ENCLOSING_CIRCLE_H
#define MIN_ENCLOSING_CIRCLE_H

#include <PLAGEO/curved.h>

/*
 * Minimal enclosing disc of a set of points.
 * The set of points must be stored in a structure that supports random access
 * via the index operator ([]). Good containers are arrays, rows and rerays.
 */

template <class ArrayContainer>
void minimal_enclosing_disc(int &i1, int &i2, int &i3,
    pl_vec &mid, s_coord &d, ArrayContainer const& points, int n);

template <class ArrayContainer>
inline void minimal_enclosing_disc(int &i1, int &i2, int &i3,
    pl_vec &mid, s_coord &d, ArrayContainer const& points)
{
    minimal_enclosing_disc(i1, i2, i3, mid, d, points, (int) (points.size()));
}

template <class ArrayContainer>
pl_disc minimal_enclosing_disc(int &i1, int &i2, int &i3,
			    ArrayContainer const& points, int n);

template <class ArrayContainer>
inline pl_disc minimal_enclosing_disc(int &i1, int &i2, int &i3,
			    ArrayContainer const& points)
{
    return minimal_enclosing_disc(i1, i2, i3, points, (int) (points.size()));
}

template <class ArrayContainer>
pl_disc minimal_enclosing_disc(ArrayContainer const& points, int n);

template <class ArrayContainer>
inline pl_disc minimal_enclosing_disc(ArrayContainer const& points)
{
    return minimal_enclosing_disc(points, (int) (points.size()));
}

#endif
