#ifndef MATHPPH
#define MATHPPH 1

#include <math.h>
#include <float.h>

#ifdef __sgi
#include <fp_class.h>

inline int fp_class_pp(double x)
{ return fp_class_d(x); }

inline int fp_class_pp(float x)
{ return fp_class_f(x); }


#endif

#ifdef _hp_ux
#endif

inline double max_of_type(double dummy)
{ dummy = dummy; return DBL_MAX; }

inline float max_of_type(float dummy)
{ dummy = dummy; return FLT_MAX; }

inline double min_of_type(double dummy)
{ dummy = dummy; return -DBL_MAX; }

inline float min_of_type(float dummy)
{ dummy = dummy; return -FLT_MAX; }

inline double sin_pp(double x)
{ return sin(x);}

// inline float sin_pp(float x)
// { return sinf(x);}

inline double cos_pp(double x)
{ return cos(x);}

// inline float cos_pp(float x)
// { return cosf(x);}

inline double tan_pp(double x)
{ return tan(x);}

// inline float tan_pp(float x)
// { return tanf(x);}

inline double asin_pp(double x)
{ return asin(x);}

// inline float asin_pp(float x)
// { return asinf(x);}

inline double acos_pp(double x)
{ return acos(x);}

// inline float acos_pp(float x)
// { return acosf(x);}

inline double atan_pp(double x)
{ return atan(x);}

// inline float atan_pp(float x)
// { return atanf(x);}

inline double atan2_pp(double y, double x)
{ return atan2(y, x);}

// inline float atan2_pp(float y, float x)
// { return atan2f(y, x);}

inline double sqrt_pp(double x)
{ return sqrt(x);}

// inline float sqrt_pp(float x)
// { return sqrtf(x);}

inline double hypot_pp(double x, double y)
{ return hypot(x, y);}

inline float hypot_pp(float x, float y)
#ifndef __sgi
{ return (float) hypot(double(x), double(y)); }
#else
{ return fhypot(x, y);}
#endif

inline double	cosh_pp(double x)
{ return cosh(x);}

// inline float	cosh_pp(float x)
// { return coshf(x);}

inline double	sinh_pp(double x)
{ return sinh(x);}

// inline float	sinh_pp(float x)
// { return sinhf(x);}

inline double	tanh_pp(double x)
{ return tanh(x);}

// inline float	tanh_pp(float x)
// { return tanhf(x);}

inline double	exp_pp(double x)
{ return exp(x);}

// inline float	exp_pp(float x)
// { return expf(x);}




inline double	log_pp(double x)
{ return log(x); }

// inline float	log_pp(float x)
// { return logf(x); }


inline double	log10_pp(double x)
{ return log10(x); }

// inline float	log10_pp(float x)
// { return log10f(x); }


inline double	modf_pp(double x, double *y)
{ return modf(x, y); }
/* version of modff implemented for completeness only */

#ifdef __sgi
inline float	modf_pp(float x, float *y)
{ return modff(x, y); } 
#endif

inline double	pow_pp(double x, double y)
{ return pow(x, y); }

/* version of powf implemented for completeness only */
// inline float	pow_pp(float x, float y)
// { return powf(x, y); }


inline double	ceil_pp(double x)
{ return ceil(x); }

inline float	ceil_pp(float x)
#ifndef __sgi
{ return (float) ceil(double(x)); }
#else
{ return ceilf(x); }
#endif

inline double	fabs_pp(double x)
{ return fabs(x); }

/* version of fabsf implemented for completeness only */
inline float	fabs_pp(float x)
{ return fabsf(x); }


inline double	floor_pp(double x)
{ return floor(x); }

inline float	floor_pp(float x)
#ifndef __sgi
{ return (float) floor(double(x)); }
#else
{ return floorf(x); }
#endif


inline double	fmod_pp(double x, double y)
{ return fmod(x, y); }

/* version of fmodf implemented for completeness only */
// inline float	fmod_pp(float x, float y)
// { return fmodf(x, y); }


#endif
