
#include <stdlib.h>
#include <math.h>



template<class T>
row<T>::row(unsigned int s)
{
    if (s==0) {
        sz = 0;
        v = 0;
    } else {
        sz = s;
        v = new T[s];
    }
}

template<class T>
row<T>::row(const row<T> & a)
{
    register int i = a.sz;
    sz = i;
    if (i==0) {
        v = 0;
    } else {
        v = new T[i];
        if ( v == 0) {
            cerr<<"Out of memory (row allocation).\n";
            abort();
        }
        register T *vv = &v[i];
        register T *av = &a.v[i];
        while (i--)
            *--vv = *--av;
    }
}

template<class T>
T row<T>::elem(unsigned int index) const
{
    if (/*index < 0 || */ index >= size()) {
        cerr<<"Out of bounds row indexing.\nCore dumped.\n";
        abort();
    }
    return operator[](index);
}

template<class T>
void row<T>::replace(unsigned int index, const T &s)
{
    if (/* index < 0 ||*/ index >= size()) {
        cerr<<"Out of bounds row indexing.\nCore dumped.\n";
        abort();
    }
    (*this)[index] = s;
}

template<class T>
void row<T>::newsize(unsigned int i)
{
    if (i != sz) {
        if (v != 0) delete [] v;
        sz = i;
        v = (sz == 0) ? 0 : new T[sz];
    }
}


template<class T>
row<T> & row<T>::operator=(const row<T> & a)
{
    if (this == &a) // x=x;
        return *this;
    int i = int(a.sz);
    newsize(i);
// copy elements
    if (i == 0)
        return *this;
    register T *vv = &(v[i]);
    register T *av = &(a.v[i]);
    while (i--)
        *--vv = *--av;
    return *this;
}

template<class T>
void row<T>::swap_contents(row<T> &rr2)
{
    T *tv;
    int tsz;
    tv = v;
    tsz = sz;
    v = rr2.v;
    sz = rr2.sz;
    rr2.v = tv;
    rr2.sz = tsz;
}

template<class T>
void row<T>::swap(unsigned int i, unsigned int j)
{
    T temp(v[i]);
    v[i] = v[j];
    v[j] = temp;
}

typedef void *voidp;

/*
 * quicksort
 * moet nog geoptimaliseerd worden:
 * bij kleine ivsize overgaan op insertionsort oid.
 * Dan geen swaps meer nodig,  maar direct in newv plaatsen.
 */
template<class T>
void row<T>::sort(int (* compare)(const T &, const T &))
{
    int             i, j;
    int             s, e, ivsize;
    int             sp = 0;
    int             pivot;
    T*              temp;
    T **            pt;
                      // lijst met pointers, deze wordt gesorteerd.
    int             low[25], high[25];
                      // plek voor stack van sorteerintervallen

    if (sz <= 1)
        return;
// initialiseer eerst volgorde array
    pt = (T**) (new voidp[int(sz)]);        // ????? should be new (T*) [sz]
    for (i = 0; i < sz; i++)
        pt[i] = v+i;
// zet eerste sorteerinterval op de stack
    low[sp] = 0;
    high[sp] = sz - 1;
    sp++;                       // PUSH(0,this->sz-1);
    while (sp != 0) {
        sp--;
        s = low[sp];
        e = high[sp];           // POP(s,e);
        ivsize = e-s+1;
    // sorting of an interval >= 3 elements
        while (ivsize >= 3) {
        // take a random pivot
            pivot = s + int(lrand48()%ivsize);
        // partition the array.
        // place keys smaller than pivot in front
            i = s;
            j = e;
            while (i <= j) {
                while (i<=j && (i==pivot||compare(*pt[i], *pt[pivot])<= 0))
                    i++;
                while (j>=i && (j==pivot||compare(*pt[j], *pt[pivot]) >= 0))
                    j--;
                if (i < j) {
                    temp = pt[i];
                    pt[i] = pt[j];
                    pt[j] = temp;
                    i++;
                    j--;
                }
            }
        // plaats de pivotwaarde op goede plek. // ?????
            if (pivot <= j) {
                if (pivot != j) {
                    temp = pt[pivot];
                    pt[pivot] = pt[j];
                    pt[j] = temp;
                }
                j--;
            } else if (pivot >= i) {
                if (pivot != i) {
                    temp = pt[pivot];
                    pt[pivot] = pt[i];
                    pt[i] = temp;
                }
                i++;
            }
        // push het grootste deelinterval op de stack, ga de volgende
        // ronde verder met het kleinste interval.
            if (e - i > j - s) {
                low[sp] = i;
                high[sp] = e;
                sp++;           // PUSH(i,e);
                e = j;
            } else {
                low[sp] = s;
                high[sp] = j;
                sp++;           // PUSH(s,j);
                s = i;
            }
            ivsize = e-s+1;
        }
    // interval van grootte 2 sorteren
        if (ivsize == 2 && compare(*pt[s], *pt[e]) > 0 ) {
            temp = pt[s];
            pt[s] = pt[e];
            pt[e] = temp;
        }
    }
// nu goedzetten van elementen
    T* newv;
    newv = new T[sz];
    for (i=0; i<sz; i++)
        newv[i] = *pt[i];
    delete [] v;
    v = newv;
    delete [] pt;
}

template<class T>
void row<T>::sort(int (* compare)(T, T))
{
    int             i, j;
    int             s, e, ivsize;
    int             sp = 0;
    int             pivot;
    T               temp;
    int             low[25], high[25];
                        // plek voor stack van sorteerintervallen.
    if (sz <= 1)
        return;
// zet eerste sorteerinterval op de stack
    low[sp] = 0;
    high[sp] = sz - 1;
    sp++;                       // PUSH(0,this->sz-1);
    while (sp != 0) {
        sp--;
        s = low[sp];
        e = high[sp];           // POP(s,e);
        ivsize = e-s+1;
    // sorteren van interval >= 3 elementen
        while (ivsize >= 3) {
        // trek een random pivot
            pivot = s + int(lrand48()%ivsize);
        // partitioneer nu het array.
        // plaats vooraan de keys kleiner dan pivot, achteraan de grotere.
            i = s;
            j = e;
            while (i <= j) {
                while (i<=j && (i==pivot||compare(v[i], v[pivot])<=0))
                    i++;
                while (j>=i && (j==pivot||compare(v[j], v[pivot])>=0))
                    j--;
                if (i < j) {
                    temp = v[i];
                    v[i] = v[j];
                    v[j] = temp;
                    i++;
                    j--;
                }
            }
        // plaats de pivotwaarde op goede plek. // ?????
            if (pivot <= j) {
                if (pivot != j) {
                    temp = v[pivot];
                    v[pivot] = v[j];
                    v[j] = temp;
                }
                j--;
            } else if (pivot >= i) {
                if (pivot != i) {
                    temp = v[pivot];
                    v[pivot] = v[i];
                    v[i] = temp;
                }
                i++;
            }
        // push het grootste deelinterval op de stack, ga de volgende
        // ronde verder met het kleinste interval.
            if (e - i > j - s) {
                low[sp] = i;
                high[sp] = e;
                sp++;           // PUSH(i,e);
                e = j;
            } else {
                low[sp] = s;
                high[sp] = j;
                sp++;           // PUSH(s,j);
                s = i;
            }
            ivsize = e-s+1;
        }
    // interval van grootte 2 sorteren
        if (ivsize == 2 && compare(v[s], v[e]) > 0 ) {
            temp = v[s];
            v[s] = v[e];
            v[e] = temp;
        }
    }
}

template<class T>
std::istream& operator>>(std::istream &is, row<T> &r)
{
    unsigned int size, i;
    is>>size;
    r.newsize(size);
    for (i=0; i<size; i++) {
        is>>r[i];
    }
    return is;
}

template<class T>
std::ostream& operator<<(std::ostream &os, const row<T> &r)
{
    unsigned int i;
    os<<r.size();
    for (i=0; i<r.size(); i++)
        os<<'\n'<<r[i];
    return os;
}
