#ifndef PLAGEO_CROSS1_H
#define PLAGEO_CROSS1_H

#include <PLAGEO/base.h>
#include <PLAGEO/onedim.h>

//  ******** INTERSECTION DECISION ROUTINES********


// ******   VEC   ******

inline bool do_cross(const pl_fixedvec &, const pl_fixedvec &)
{ return false; }

inline bool do_cross(const pl_fixedvec &, const pl_box &)
{ return false; }


// ******   POINT   ******

inline bool do_cross(const pl_point &, const pl_fixedvec &)
{ return false; }

inline bool do_cross(const pl_point &, const pl_box &)
{ return false; }



// ******   EDGE   ******

extern bool do_intersect(const pl_edge_ifc &e1, const pl_edge_ifc &e2);

extern bool do_intersect(const pl_edge_ifc &e1, const pl_ray &e2);

extern bool do_intersect(const pl_edge_ifc &e, const pl_line &l);

inline bool do_cross(const pl_edge_ifc &, const pl_fixedvec &)
{ return false; }

inline bool do_cross(const pl_edge_ifc &, const pl_point &)
{ return false; }

inline bool do_cross(const pl_edge_ifc &edge1, const pl_edge_ifc &edge2)
{ return do_intersect(edge1, edge2); }

inline bool do_cross(const pl_edge_ifc &edge, const pl_ray &ray)
{ return do_intersect(edge, ray); }

inline bool do_cross(const pl_edge_ifc &edge, const pl_line &line)
{ return do_intersect(edge, line); }

extern bool do_cross(const pl_edge_ifc &, const pl_box &);


// ******   RAY   ******

inline bool do_intersect(const pl_ray &ray, const pl_edge_ifc &edge)
{ return do_intersect(edge, ray); }

extern bool do_intersect(const pl_ray &, const pl_ray &);

extern bool do_intersect(const pl_ray &, const pl_line &);



inline bool do_cross(const pl_ray &, const pl_fixedvec &)
{ return false; }

inline bool do_cross(const pl_ray &, const pl_point &)
{ return false; }

inline bool do_cross(const pl_ray &ray, const pl_edge_ifc &edge)
{ return do_intersect(ray, edge); }

inline bool do_cross(const pl_ray &ray1, const pl_ray &ray)
{ return do_intersect(ray1, ray); }

inline bool do_cross(const pl_ray &ray, const pl_line &line)
{ return do_intersect(ray, line); }

extern bool do_cross(const pl_ray &, const pl_box &);


// ******   LINE   ******


inline bool do_intersect(const pl_line &line, const pl_edge_ifc &edge)
{ return do_intersect(edge, line); }

inline bool do_intersect(const pl_line &line, const pl_ray &ray)
{ return do_intersect(ray, line); }

inline bool do_intersect(const pl_line &, const pl_line &)
{
    return true;
//    pl_vec dummy;
//    return intersect(dummy, l1, l2);
}


inline bool do_cross(const pl_line &, const pl_fixedvec &)
{ return false; }

inline bool do_cross(const pl_line &, const pl_point &)
{ return false; }

inline bool do_cross(const pl_line &line, const pl_edge_ifc &edge)
{ return do_intersect(edge, line); }

inline bool do_cross(const pl_line &line1, const pl_ray &ray)
{ return do_intersect(line1, ray); }

inline bool do_cross(const pl_line &, const pl_line &)
{ return true; }

extern bool do_cross(const pl_line &, const pl_box &);



// ******   BOX   ******

inline bool do_cross(const pl_box &, const pl_fixedvec &)
{ return false;}

inline bool do_cross(const pl_box &, const pl_point &)
{ return false;}

inline bool do_cross( const pl_box &box, const pl_edge_ifc &edge)
{ return do_cross(edge, box); }

inline bool do_cross(const pl_box &box, const pl_ray &ray)
{ return do_cross(ray, box); }

inline bool do_cross(const pl_box &box, const pl_line &line)
{ return do_cross(line, box); }

extern bool do_cross(const pl_box &, const pl_box &);


// ******** OTHER ROUTINES (internal use) ********

extern bool pl__ontbind2(s_coord fac[], const pl_vec &e0, const pl_vec &e1,
                 const pl_vec &v);

#endif //PLAGEO_CROSS1_H
