#ifndef PLAGEO_GLSUBWIN_H
#define PLAGEO_GLSUBWIN_H

#include <PLAGEO/drawarea.h>

class pl_glsubwin: public pl_drawarea {
public:
		pl_glsubwin() ;
		pl_glsubwin(int x, int y, int dx, int dy) ;
		~pl_glsubwin();
    void	pageready();
    void	clear();
    void	draw(const pl_fixedvec &);
    void	draw(const pl_edge_ifc &);
    void	draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void	draw(const pl_line &line)   { pl_drawarea::draw(line); }
    void	draw(const pl_arc &);
    void    	draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void    	draw(const pl_pgn_ifc &);
    void	draw(const pl_disc &);
    void	draw_text(const pl_fixedvec&, const char*) ;
    void	set_renderarea(int x, int y, int dx, int dy) ;
    void	set_colorfunc(void (*cf)(int) ) {_colorfunc = cf; }
protected:
    int		_cleanpage;
    short	_winx, _winy, _windx, _windy;
    void (*_colorfunc) (int) ;
    float	_savemat[4][4];
    long	_prevmode;
    void	init_page();
};

extern void pl_use_colormap(int col);

extern void pl_use_rgbcolor(int col);

extern void pl_use_autocolor(int col);

#endif // PLAGEO_GLSUBWIN_H
