#ifndef PLAGEO_GLWIN_H
#define PLAGEO_GLWIN_H

#include <PLAGEO/drawarea.h>

//extern void pl_draw(const pl_fixedvec &vt, int how, s_coord radius);
//extern void pl_draw(const pl_edge_ifc &e);
extern void pl_draw(const pl_pgn_ifc &pgn, int how);
// 0:outline;  1:inside;

class pl_glwindow: public pl_drawarea {
public:
		pl_glwindow() ;
		pl_glwindow(int dx, int dy) ;
		pl_glwindow(int x, int y, int dx, int dy) ;
		~pl_glwindow();
    int		set_directshow(int);
    void	pageready();
    void	clear();
    void	hide();
    void	draw(const pl_fixedvec &);
    void	draw(const pl_edge_ifc &);
    void	draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void	draw(const pl_line &line)   { pl_drawarea::draw(line); }
    void	draw(const pl_arc &);
    void    	draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void    	draw(const pl_pgn_ifc &);
    void	draw(const pl_disc &);
    void	draw_text(const pl_fixedvec&, const char*) ;
    long	identifier() const ;
    pl_vec	get_mouseposition() ;
    int		get_mousestatus(int) ;
    void	set_name(const char *name) ;
protected:
    long	winid;
    int		_ds;
    int		_background_dirty;
    long	_winx, _winy, _windx, _windy;
    char	*_name;
    void	win_init();
    class active_win {
    public:
	active_win(long winid) ;
	~active_win();
    protected:
	long    _keepwin;
	long    _curwin;
    };
};

#endif // PLAGEO_GLWIN_H
