#ifndef PLAGEO_INTERVALS_H
#define PLAGEO_INTERVALS_H

#include <PLAGEO/base.h>

typedef reray<s_coord> s_coordreray;

class intervals {
public:
    bool		starts_at_min_infinity;	// boolean
    s_coordreray	boundaries;	// sorted reray of boundaries of intervals
		intervals() : starts_at_min_infinity(false) {}
    void	toggle();
    void	toggle_after(s_coord x);
    bool	is_empty() const;
    bool	lies_in(s_coord) const;
    int		find_index_after(s_coord x) const;
    bool	is_interval_endpoint(int index) const;
};

extern intervals operator&(const intervals &,
				const intervals &);

extern intervals operator|(const intervals &,
				const intervals &);

extern intervals operator^(const intervals &,
				const intervals &);

// shortest gap gives the shortest distance between an interval in a to
// an interval in b. It will be zero if a&b is not empty.
extern s_coord shortest_gap(const intervals &a, const intervals &b);



// zeer voorlopig class design
class pl_dotted_line {
public:
    intervals fiv;
    pl_vec reference_vertex;
    pl_unitvec dir;
    pl_unitvec	direction() const	{return dir;}
    pl_vec	ref_vt() const	{return reference_vertex;}
protected:
};

#endif // PLAGEO_INTERVALS_H
