#ifndef PLAGEO_IO_H
#define PLAGEO_IO_H

#include <PLAGEO/base.h>
#include <PLAGEO/onedim.h>
#include <PLAGEO/curved.h>
#include <PLAGEO/pgn_ifc.h>


extern ostream & operator<<(ostream &ofile, const pl_angle &);
extern istream & operator>>(istream &ifile, pl_angle &);


extern ostream & operator<<(ostream &ofile, const pl_fixedvec &vec);
extern istream & operator>>(istream &ifile, pl_vec &vec);
extern istream & operator>>(istream &ifile, pl_unitvec &uvec);

inline ostream & operator<<(ostream &ofile, const pl_point &vt)
{ return ofile<<vt.vec(); }
extern istream & operator>>(istream &ifile, pl_point &pt);


extern ostream & operator<<(ostream &ofile, const pl_edge_ifc &edge);
extern istream & operator>>(istream &ifile, pl_edge_ifc &edge);

extern ostream & operator<<(ostream &ofile, const pl_ray &ray);
extern istream & operator>>(istream &ifile, pl_ray &ray);

extern ostream & operator<<(ostream &ofile, const pl_line &line);
extern istream & operator>>(istream &ifile, pl_line &line);

extern ostream & operator<<(ostream &ofile, const pl_arc &arc);
extern istream & operator>>(istream &ifile, pl_arc &arc);

extern ostream & operator<<(ostream &ofile, const pl_box &box);
extern istream & operator>>(istream &ifile, pl_box &box);

extern ostream & operator<<(ostream &ofile, const pl_pgn_ifc &pgn);
extern istream & operator>>(istream &ifile, pl_pgn_ifc &pgn);

extern ostream & operator<<(ostream &ofile, const pl_disc &disc);
extern istream & operator>>(istream &ifile, pl_disc &disc);

/*
extern ostream & operator<<(ostream &ofile, const pl_vecreray &);
extern istream & operator>>(istream &ifile, pl_vecreray &);

extern ostream & operator<<(ostream &ofile, const pl_edgereray &);
extern istream & operator>>(istream &ifile, pl_edgereray &);

extern ostream & operator<<(ostream &ofile, const pl_polygonreray &);
extern istream & operator>>(istream &ifile, pl_polygonreray &);
*/

#endif // PLAGEO_IO_H
