#ifndef PLAGEO_IPEFILE_H
#define PLAGEO_IPEFILE_H

#include <PLAGEO/drawarea.h>


class pl_ipefile: public pl_drawarea {
public:
		pl_ipefile(ostream &os) ;
		~pl_ipefile();
    void	pageready();
    void	clear();
    void	draw(const pl_fixedvec &);
    void	draw(const pl_edge_ifc &);
    void	draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void	draw(const pl_line &line)	    { pl_drawarea::draw(line); }
    void	draw(const pl_arc &);
    void	draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void	draw(const pl_pgn_ifc &);
    void	draw(const pl_disc &);
    void	draw_text(const pl_fixedvec&, const char*) ;
protected:
    void	ipe_init();
    void	page_init();
    pl_vec	to_ipe_coord(const pl_fixedvec &vt) const;
    s_coord	to_ipe_size(s_coord) const;
    pl_box	viewing_box() const;
    ostream	&out;
    int		_newpage;	// 1 if page is not initialised, 0 otherwise.
};

#endif // PLAGEO_IPEFILE_H
