#ifndef PL_OGL_RENDERER_H
#define PL_OGL_RENDERER_H 1

#include <PLAGEO/drawarea.h>

struct pl_ogl_renderer: public pl_drawarea {
    enum fitting_modes { STRETCH, CUT_OFF, ADD_EXTRA, ADD_EMPTY};
	    pl_ogl_renderer() ;
	    ~pl_ogl_renderer() ;
    void    clear();
    void    draw(const pl_fixedvec &);
    void    draw(const pl_edge_ifc &);
    void    draw(const pl_arc &);
    void    draw(const pl_pgn_ifc &);
    void    draw(const pl_disc &);
    void    draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void    draw(const pl_line &line)	    { pl_drawarea::draw(line); }
    void    draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void    draw_text(const pl_fixedvec&, const char*);
    void    pageready();
    void    set_viewport(int x, int y, int dx, int dy);
    void    get_viewport(int &x, int &y, int &dx, int &dy);
    fitting_modes    set_fitting_mode(fitting_modes ) ;
    bool    to_scene_coords(pl_vec &result, int winx, int winy);
protected:
    int	    _winx, _winy, _windx, _windy;
    GLint   _vp_dx, _vp_dy;
    GLdouble _width, _height;
    bool    _cleanpage;
    fitting_modes _fitting_mode;
    void    init_page();
    void    init_projection();
};

#endif
