#ifndef PL_OGL_WIDGET_H
#define PL_OGL_WIDGET_H 1

#include <Xm/Xm.h>
#include <GL/GLwMDrawA.h>
#include <PLAGEO/drawarea.h>
#include <PLAGEO/ogl_smart_renderer.h>

struct pl_ogl_smart_widget: public pl_ogl_smart_renderer {
	    pl_ogl_smart_widget() {}
	    pl_ogl_smart_widget(Widget parent, char *name = "pl_ogl_smart_widget",
		    bool draw_immediate = true) ;
	    ~pl_ogl_smart_widget() ;
    void    clear();
    void    draw(const pl_fixedvec &);
    void    draw(const pl_edge_ifc &);
    void    draw(const pl_arc &);
    void    draw(const pl_pgn_ifc &);
    void    draw(const pl_disc &);
    void    draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void    draw(const pl_line &line)	    { pl_drawarea::draw(line); }
    void    draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void    draw_text(const pl_fixedvec&, const char*);
    void    pageready();
    void    widget_init(Widget parent, char *name = "pl_ogl_smart_widget",
		bool draw_immediate = true);
    const GLXContext & glx_context() const { return _glx_context; }
    const reray<GLuint> &draw_list() const { return _draw_list; }
    void    make_current();
protected:
    Widget	    _ogl_widget;
    GLXContext	    _glx_context;
    bool	    _first_time;
friend void init_window(Widget w, XtPointer client, XtPointer);
friend void draw_scene_callback(Widget w, XtPointer client, XtPointer call);
};


#endif
