#ifndef PLAGEO_PGN_IFC_H
#define PLAGEO_PGN_IFC_H

#include <PLAGEO/base.h>
#include <PLAGEO/onedim.h>


class pl_pgn_ifc: public pl_object {
public:
	pl_object_type  type() const;
virtual void		operator=(const pl_pgn_ifc &) = 0;
virtual int		element(int i) const = 0;
virtual const pl_vec &	velement(int i) const = 0;
virtual int		order(int i) const = 0;
virtual bool		is_ok()	const = 0;
virtual bool		is_clockwise() const = 0;
virtual void		invert_orientation() = 0;
virtual bool		is_convex() const = 0;
virtual int		size() const = 0;
virtual const pl_vec &	vertex(int i) const = 0;
virtual const pl_vec &	vertex_mod(int i) const;
virtual s_coord		area() const = 0;

virtual void		set_edge(int i) const = 0;
virtual void		set_edge_mod(int i) const;
virtual const pl_edge_ifc &cur_edge() const = 0;
virtual const pl_unitvec &cur_direction() const = 0;
//protected:
virtual void		make_start(int n) = 0;
virtual void		set_vertex(int i, const pl_vec &) = 0;
virtual void		make_ready() = 0;
//friend template <class T> make(pl_pgn_ifc &pgn, T start, int n);
};

template <class Input_Iterator>
inline void make_pgn(pl_pgn_ifc &pgn, Input_Iterator start, int n)
{
    int i;
    pgn.make_start(n);
    for (i=0; i<n; i++)
	pgn.set_vertex(i, *start++);
    pgn.make_ready();
}

template <class Input_Iterator1, class Input_Iterator2>
inline void make_pgn(pl_pgn_ifc &pgn, Input_Iterator1 x, Input_Iterator2 y, int n)
{
    int i;
    pgn.make_start(n);
    for (i=0; i<n; i++) {
	pl_vec vec(*x++, *y++);
	pgn.set_vertex(i, vec);
    }
    pgn.make_ready();
}



#endif // PLAGEO_PGN_IFC_H
