#ifndef PLAGEO_PSFILE_H
#define PLAGEO_PSFILE_H

#include <PLAGEO/drawarea.h>

class pl_psfile: public pl_drawarea {
public:
	    pl_psfile(ostream &os) ;
	    pl_psfile(ostream &os, int xoffset, int yoffset, int xsize, int ysize) ;
	    ~pl_psfile();
    void    pageready();
    void    clear();
    void    draw(const pl_fixedvec &);
    void    draw(const pl_edge_ifc &);
    void    draw(const pl_ray &ray)	    { pl_drawarea::draw(ray); }
    void    draw(const pl_line &line)	    { pl_drawarea::draw(line); }
    void    draw(const pl_arc &);
    void    draw(const pl_box &box)	    { pl_drawarea::draw(box); }
    void    draw(const pl_pgn_ifc &);
    void    draw(const pl_disc &);
    void    draw_text(const pl_fixedvec&, const char*) ;
protected:
    void    ps_init();
    void    page_init();
    void    setcol(int col);
    ostream &out;
    int	    _newpage;	// 1 if page is not initialised, 0 otherwise.
    int	    _image_xsize;
    int	    _image_ysize;
    int	    _x_offset;
    int	    _y_offset;
    int	    _pagenumber;
    char    _marked[PL_COLORCOUNT];
};

#endif // PLAGEO_PSFILE_H
