#ifndef PLAGEO_SWEEPLIST_H
#define PLAGEO_SWEEPLIST_H

#include <PLAGEO/base.h>


class pl_sweeplist_node ;

typedef pl_sweeplist_node *pl_sweep_item;


struct pl_sweeplist {
		    pl_sweeplist(int (*search_func)(const pl_vec &, void*)) ;
		    ~pl_sweeplist() ;
    bool	    is_empty() const;
    int		    search(pl_sweep_item &result, const pl_vec &) const;
    pl_sweep_item   first() const;
    pl_sweep_item   last() const;
    pl_sweep_item   pred(pl_sweep_item) const;
    pl_sweep_item   succ(pl_sweep_item) const;
    void*	    info(pl_sweep_item) const;
    bool	    is_valid_item(pl_sweep_item) const;
    bool	    is_valid_search_key(const pl_vec &) const;
    pl_sweep_item   insert_first(void*);
    pl_sweep_item   insert_before(pl_sweep_item, void*);
    pl_sweep_item   insert_after(pl_sweep_item, void*);
    pl_sweep_item   find_and_insert(const pl_vec &, void*);
    void	    exchange(pl_sweep_item, pl_sweep_item);
    void	    remove(pl_sweep_item);
    void	    clear();
protected:
    pl_sweep_item   _highest;   // first node of highest level
    int		    (*_cmp)(const pl_vec &, void*);
    int		    search_before(pl_sweep_item &result, const pl_vec & key,
			pl_sweep_item cur, int level) const;
    int		    search_after(pl_sweep_item &result, const pl_vec & key,
			pl_sweep_item cur, int level) const;
    pl_sweep_item   new_pl_sweep_item() ;
    bool	    is_consistent() const;
};

#endif // PLAGEO_SWEEPLIST_H
