#include <gl/gl.h>
#include <gl/device.h>
#include <fmclient.h>
#include <PLAGEO/glwin.h>


void pl_glwindow::draw_text(const pl_fixedvec &vt, const char *str)
{
    static fmfonthandle font1, font2=0;
    static double scale = -1;	// scale factor of font2.
    double newscale;
    static float pixelsize;	// size of 1 pixel in points.
    static int initialised = 0;
    win_init();
    active_win aw(winid);
    if (!initialised) {
	initialised = 1;
	pixelsize = (2.835*getgdesc(GD_XMMAX))/getgdesc(GD_XPMAX);
	fminit();
	font1 = fmfindfont("Helvetica");
	if (font1 == 0) return;
    }
    getsize(&_windx, &_windy);
    long pixelcount = _windx>_windy ? _windx : _windy;
    newscale = 0.001*_textsize*pixelcount*pixelsize;
    if (newscale != scale) {
	scale = newscale;
	font2 = fmscalefont(font1, scale);
    }
    if (font2 == 0) return;
    fmsetfont(font2);
    color(_textcol);
    cmov2(vt.x(), vt.y());
    fmprstr(str);
}
